#include <mega640.h>
#include <stdio.h>
#include <delay.h>
#include "BLDC_T3.h"

unsigned char drvPatternsCW[] = {
  					0,    //Stop
					// MC_PORT drive config
//					PDP2_CW, //Phase2 1,2
//                    PDP6_CW, //Phase6 3,4 					
//                    PDP1_CW, //Phase1 3,2					
//					PDP4_CW, //Phase4 5,6                    
//					PDP3_CW, //Phase3 1,6                    
//					PDP5_CW,  //Phase5 5,4
                    PDP5_CW,  //Phase5 5,4
					PDP3_CW, //Phase3 1,6
					PDP4_CW, //Phase4 5,6
                    PDP1_CW, //Phase1 3,2
                    PDP6_CW, //Phase6 3,4                                                                                                                      
                    PDP2_CW, //Phase2 1,2
                    COM5P5_CW,
                    COM5P3_CW,
                    COM5P4_CW,
                    COM5P1_CW,
                    COM5P6_CW,
                    COM5P2_CW                    
				};

unsigned char *pDrvPattern;

unsigned int word;

unsigned char hallMask;

void init_timer5(void)
    {
    TCCR5A=(1<<COM5A1)|(0<<COM5A0)|(1<<COM5B1)|(0<<COM5B0)|(1<<COM5C1)|(0<<COM5C0)|(1<<WGM51)|(0<<WGM50);
    TCCR5B=(0<<ICNC5)|(0<<ICES5)|(1<<WGM53)|(1<<WGM52)|(1<<CS52)|(0<<CS51)|(0<<CS50);
    ICR5H=0x01;
    ICR5L=0x03;
    TCNT5H = 0;
    TCNT5L = 0;
    TIFR5 = TIFR5;
    }

interrupt [PC_INT1] void pinchange_interrupt_isr1()
	{
		unsigned char *pTemp;
		word = (PIN_HALL&hallMask);
		pTemp = pDrvPattern + word;
        TCCR5A=0;
		PORT_MC = *(pTemp);
        TCCR5A = *(pTemp+PATTERN_COM5_OFFSET);
	}
void init_pin_change_int(void)
	{
	 PCMSK0=0x00;
         PCMSK1=0x0E;
         PCMSK2=0x00;
         PCICR=0x02;
         PCIFR=0x02;

	}
void main(void)

	{ 
    init_timer5();
	pDrvPattern = drvPatternsCW;
	hallMask = HALL_MASK;
    init_pin_change_int();
	DDR_HALL |= HALL_MASK;    //Lock HALL sensor by driving Hall lines
	PORT_HALL |= HALL_MASK;
	PORT_HALL &= ~HALL_MASK;  //Release HALL sensor lines and trigger PC interrupt
	DDR_HALL &= ~HALL_MASK; 
    #asm("sei");
    OCR5AH=0x01;
    OCR5AL=0x03;
    OCR5BH=0x01;
    OCR5BL=0x03;
    OCR5CH=0x01;    
    OCR5CL=0x03;
	DDR_MC = MC_MASK;	//enable outputs
	while(1);

	}